/*
 * Copyright (c) 2015, University of Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Janik Schlemminger
 *    Robert Gernhardt
 *    Matthias Jung
 */

#include "commenttreewidget.h"
#include <QTreeWidgetItem>
#include <iostream>
#include <QMenu>

void CommentTreeWidget::init(TraceNavigator *navigator)
{
    Q_ASSERT(isInitialized == false);
    isInitialized = true;
    this->navigator = navigator;
    setColumnCount(2);
    setHeaderLabels(QStringList({"Time", "Comment"}));
    QObject::connect(navigator, SIGNAL(commentsChanged()), this,
                     SLOT(commentsChanged()));
    QObject::connect(this, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)), this,
                     SLOT(itemDoubleClicked(QTreeWidgetItem *, int)));
    QObject::connect(this, SIGNAL(customContextMenuRequested(QPoint)), this,
                     SLOT(ContextMenuRequested(QPoint)));
    setContextMenuPolicy(Qt::CustomContextMenu);
    deleteComment = new QAction("Delete comment", this);
    printComments();
}

void CommentTreeWidget::commentsChanged()
{
    clear();
    printComments();
}

void CommentTreeWidget::printComments()
{
    for (const auto &pair : navigator->getComments()) {
        const Comment &comment = pair.second;
        QTreeWidgetItem *item = new CommentTreeItem(this, comment);
        addTopLevelItem(item);
    }
    resizeColumnToContents(0);
}

void CommentTreeWidget::itemDoubleClicked(QTreeWidgetItem *item, int /*column*/)
{
    CommentTreeItem *commentItem = static_cast<CommentTreeItem *>(item);
    navigator->navigateToTime(commentItem->Time());
}

void CommentTreeWidget::ContextMenuRequested(QPoint point)
{
    QMenu contextMenu;
    contextMenu.addActions({deleteComment});
    QAction *selectedItem = contextMenu.exec(mapToGlobal(point));

    if (selectedItem) {
        for (QTreeWidgetItem *item : selectedItems()) {
            CommentTreeItem *commentItem = static_cast<CommentTreeItem *>(item);
            navigator->removeCommentAtTime(commentItem->Time());
        }
    }
}


CommentTreeWidget::CommentTreeItem::CommentTreeItem(QTreeWidget *parent,
                                                    const Comment &comment): QTreeWidgetItem(parent), comment(comment)
{
    this->setText(0, prettyFormatTime(comment.Time()));
    this->setText(1, comment.Text());
}
